/* 
 * custom-element-types.module.ts
 * Generated with https://github.com/blueprintui/custom-element-types
 */
import { Directive, Input, Output, EventEmitter, ElementRef } from '@angular/core';
import type { BpAccordionContent } from '@blueprintui/components/accordion/content/element.js';
import type { BpAccordion } from '@blueprintui/components/accordion/element.js';
import type { BpAccordionHeader } from '@blueprintui/components/accordion/header/element.js';
import type { BpAccordionPanel } from '@blueprintui/components/accordion/panel/element.js';
import type { BpAlert } from '@blueprintui/components/alert/element.js';
import type { BpAlertGroup } from '@blueprintui/components/alert/group/element.js';
import type { BpBadge } from '@blueprintui/components/badge/element.js';
import type { BpBreadcrumb } from '@blueprintui/components/breadcrumb/element.js';
import type { BpButtonExpand } from '@blueprintui/components/button-expand/element.js';
import type { BpButtonGroup } from '@blueprintui/components/button-group/element.js';
import type { BpButtonHandle } from '@blueprintui/components/button-handle/element.js';
import type { BpButtonIconGroup } from '@blueprintui/components/button-icon-group/element.js';
import type { BpButtonIcon } from '@blueprintui/components/button-icon/element.js';
import type { BpButtonResize } from '@blueprintui/components/button-resize/element.js';
import type { BpButtonSort } from '@blueprintui/components/button-sort/element.js';
import type { BpButton } from '@blueprintui/components/button/element.js';
import type { BpCard } from '@blueprintui/components/card/element.js';
import type { BpChatMessage } from '@blueprintui/components/chat/element.js';
import type { BpChatGroup } from '@blueprintui/components/chat/group/element.js';
import type { BpCheckbox } from '@blueprintui/components/checkbox/element.js';
import type { BpColor } from '@blueprintui/components/color/element.js';
import type { BpDate } from '@blueprintui/components/date/element.js';
import type { BpDialog } from '@blueprintui/components/dialog/element.js';
import type { BpDivider } from '@blueprintui/components/divider/element.js';
import type { BpDrawer } from '@blueprintui/components/drawer/element.js';
import type { BpDropdown } from '@blueprintui/components/dropdown/element.js';
import type { BpFile } from '@blueprintui/components/file/element.js';
import type { BpFormatDatetime } from '@blueprintui/components/format-datetime/element.js';
import type { BpFormatNumber } from '@blueprintui/components/format-number/element.js';
import type { BpFieldMessage } from '@blueprintui/components/forms/field-message/element.js';
import type { BpField } from '@blueprintui/components/forms/field/element.js';
import type { BpFieldset } from '@blueprintui/components/forms/fieldset/element.js';
import type { BpFormGroup } from '@blueprintui/components/forms/form-group/element.js';
import type { BpHeader } from '@blueprintui/components/header/element.js';
import type { BpHeaderItem } from '@blueprintui/components/header/item/element.js';
import type { BpInput } from '@blueprintui/components/input/element.js';
import type { BpMenu } from '@blueprintui/components/menu/element.js';
import type { BpMenuItem } from '@blueprintui/components/menu/item/element.js';
import type { BpMonth } from '@blueprintui/components/month/element.js';
import type { BpNav } from '@blueprintui/components/nav/element.js';
import type { BpNavGroup } from '@blueprintui/components/nav/group/element.js';
import type { BpNavItem } from '@blueprintui/components/nav/item/element.js';
import type { BpPagination } from '@blueprintui/components/pagination/element.js';
import type { BpPaginationInput } from '@blueprintui/components/pagination/input/element.js';
import type { BpPassword } from '@blueprintui/components/password/element.js';
import type { BpPopover } from '@blueprintui/components/popover/element.js';
import type { BpProgressBar } from '@blueprintui/components/progress-bar/element.js';
import type { BpProgressCircle } from '@blueprintui/components/progress-circle/element.js';
import type { BpProgressDot } from '@blueprintui/components/progress-dot/element.js';
import type { BpRadio } from '@blueprintui/components/radio/element.js';
import type { BpRange } from '@blueprintui/components/range/element.js';
import type { BpRating } from '@blueprintui/components/rating/element.js';
import type { BpSearch } from '@blueprintui/components/search/element.js';
import type { BpSelect } from '@blueprintui/components/select/element.js';
import type { BpShell } from '@blueprintui/components/shell/element.js';
import type { BpStepper } from '@blueprintui/components/stepper/element.js';
import type { BpStepperItem } from '@blueprintui/components/stepper/item/element.js';
import type { BpSwitch } from '@blueprintui/components/switch/element.js';
import type { BpTabs } from '@blueprintui/components/tabs/element.js';
import type { BpTabList } from '@blueprintui/components/tabs/list/element.js';
import type { BpTabPanel } from '@blueprintui/components/tabs/panel/element.js';
import type { BpTab } from '@blueprintui/components/tabs/tab/element.js';
import type { BpTag } from '@blueprintui/components/tag/element.js';
import type { BpTextarea } from '@blueprintui/components/textarea/element.js';
import type { BpTime } from '@blueprintui/components/time/element.js';
import type { BpToast } from '@blueprintui/components/toast/element.js';
import type { BpTooltip } from '@blueprintui/components/tooltip/element.js';
import type { BpTree } from '@blueprintui/components/tree/element.js';
import type { BpTreeItem } from '@blueprintui/components/tree/item/element.js';


@Directive({ selector: 'bp-accordion-content', standalone: true })
export class BpAccordionContentDirective {
  protected element: Partial<BpAccordionContent>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-accordion', standalone: true })
export class BpAccordionDirective {
  protected element: Partial<BpAccordion>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-accordion-header', standalone: true })
export class BpAccordionHeaderDirective {
  protected element: Partial<BpAccordionHeader>;

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-accordion-panel', standalone: true })
export class BpAccordionPanelDirective {
  protected element: Partial<BpAccordionPanel>;

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-alert', standalone: true })
export class BpAlertDirective {
  protected element: Partial<BpAlert>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('') Event: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-alert-group', standalone: true })
export class BpAlertGroupDirective {
  protected element: Partial<BpAlertGroup>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-badge', standalone: true })
export class BpBadgeDirective {
  protected element: Partial<BpBadge>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-breadcrumb', standalone: true })
export class BpBreadcrumbDirective {
  protected element: Partial<BpBreadcrumb>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-expand', standalone: true })
export class BpButtonExpandDirective {
  protected element: Partial<BpButtonExpand>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set checked(value: boolean | '') { this.element.checked = value === '' ? true : value; }
  get checked() { return this.element.checked; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set action(value) { this.element.action = value; }
  get action() { return this.element.action; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-group', standalone: true })
export class BpButtonGroupDirective {
  protected element: Partial<BpButtonGroup>;

  @Input() set action(value) { this.element.action = value; }
  get action() { return this.element.action; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-handle', standalone: true })
export class BpButtonHandleDirective {
  protected element: Partial<BpButtonHandle>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set shape(value) { this.element.shape = value; }
  get shape() { return this.element.shape; }

  @Input() set action(value) { this.element.action = value; }
  get action() { return this.element.action; }

  @Input() set direction(value) { this.element.direction = value; }
  get direction() { return this.element.direction; }

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-icon-group', standalone: true })
export class BpButtonIconGroupDirective {
  protected element: Partial<BpButtonIconGroup>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-icon', standalone: true })
export class BpButtonIconDirective {
  protected element: Partial<BpButtonIcon>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set shape(value) { this.element.shape = value; }
  get shape() { return this.element.shape; }

  @Input() set action(value) { this.element.action = value; }
  get action() { return this.element.action; }

  @Input() set direction(value) { this.element.direction = value; }
  get direction() { return this.element.direction; }

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-resize', standalone: true })
export class BpButtonResizeDirective {
  protected element: Partial<BpButtonResize>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set step(value) { this.element.step = value; }
  get step() { return this.element.step; }

  @Input() set direction(value) { this.element.direction = value; }
  get direction() { return this.element.direction; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button-sort', standalone: true })
export class BpButtonSortDirective {
  protected element: Partial<BpButtonSort>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-button', standalone: true })
export class BpButtonDirective {
  protected element: Partial<BpButton>;

  @Input() set action(value) { this.element.action = value; }
  get action() { return this.element.action; }

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-card', standalone: true })
export class BpCardDirective {
  protected element: Partial<BpCard>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-chat-message', standalone: true })
export class BpChatMessageDirective {
  protected element: Partial<BpChatMessage>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set color(value) { this.element.color = value; }
  get color() { return this.element.color; }

  @Input() set arrow(value) { this.element.arrow = value; }
  get arrow() { return this.element.arrow; }

  @Input() set progress(value: boolean | '') { this.element.progress = value === '' ? true : value; }
  get progress() { return this.element.progress; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-chat-group', standalone: true })
export class BpChatGroupDirective {
  protected element: Partial<BpChatGroup>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-checkbox', standalone: true })
export class BpCheckboxDirective {
  protected element: Partial<BpCheckbox>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set checked(value: boolean | '') { this.element.checked = value === '' ? true : value; }
  get checked() { return this.element.checked; }

  @Input() set indeterminate(value: boolean | '') { this.element.indeterminate = value === '' ? true : value; }
  get indeterminate() { return this.element.indeterminate; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-color', standalone: true })
export class BpColorDirective {
  protected element: Partial<BpColor>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-date', standalone: true })
export class BpDateDirective {
  protected element: Partial<BpDate>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-dialog', standalone: true })
export class BpDialogDirective {
  protected element: Partial<BpDialog>;

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set trigger(value) { this.element.trigger = value; }
  get trigger() { return this.element.trigger; }

  @Input() set modal(value: boolean | '') { this.element.modal = value === '' ? true : value; }
  get modal() { return this.element.modal; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-divider', standalone: true })
export class BpDividerDirective {
  protected element: Partial<BpDivider>;

  @Input() set orientation(value) { this.element.orientation = value; }
  get orientation() { return this.element.orientation; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-drawer', standalone: true })
export class BpDrawerDirective {
  protected element: Partial<BpDrawer>;

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-dropdown', standalone: true })
export class BpDropdownDirective {
  protected element: Partial<BpDropdown>;

  @Input() set anchor(value) { this.element.anchor = value; }
  get anchor() { return this.element.anchor; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set trigger(value) { this.element.trigger = value; }
  get trigger() { return this.element.trigger; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-file', standalone: true })
export class BpFileDirective {
  protected element: Partial<BpFile>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set accept(value) { this.element.accept = value; }
  get accept() { return this.element.accept; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-format-datetime', standalone: true })
export class BpFormatDatetimeDirective {
  protected element: Partial<BpFormatDatetime>;

  @Input() set locale(value) { this.element.locale = value; }
  get locale() { return this.element.locale; }

  @Input() set weekday(value) { this.element.weekday = value; }
  get weekday() { return this.element.weekday; }

  @Input() set year(value) { this.element.year = value; }
  get year() { return this.element.year; }

  @Input() set month(value) { this.element.month = value; }
  get month() { return this.element.month; }

  @Input() set day(value) { this.element.day = value; }
  get day() { return this.element.day; }

  @Input() set hour(value) { this.element.hour = value; }
  get hour() { return this.element.hour; }

  @Input() set minute(value) { this.element.minute = value; }
  get minute() { return this.element.minute; }

  @Input() set second(value) { this.element.second = value; }
  get second() { return this.element.second; }

  @Input() set dateStyle(value) { this.element.dateStyle = value; }
  get dateStyle() { return this.element.dateStyle; }

  @Input() set timeStyle(value) { this.element.timeStyle = value; }
  get timeStyle() { return this.element.timeStyle; }

  @Input() set timeZoneName(value) { this.element.timeZoneName = value; }
  get timeZoneName() { return this.element.timeZoneName; }

  @Input() set timeZone(value) { this.element.timeZone = value; }
  get timeZone() { return this.element.timeZone; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-format-number', standalone: true })
export class BpFormatNumberDirective {
  protected element: Partial<BpFormatNumber>;

  @Input() set format(value) { this.element.format = value; }
  get format() { return this.element.format; }

  @Input() set currency(value) { this.element.currency = value; }
  get currency() { return this.element.currency; }

  @Input() set locales(value) { this.element.locales = value; }
  get locales() { return this.element.locales; }

  @Input() set currencySign(value) { this.element.currencySign = value; }
  get currencySign() { return this.element.currencySign; }

  @Input() set currencyDisplay(value) { this.element.currencyDisplay = value; }
  get currencyDisplay() { return this.element.currencyDisplay; }

  @Input() set compactDisplay(value) { this.element.compactDisplay = value; }
  get compactDisplay() { return this.element.compactDisplay; }

  @Input() set unitDisplay(value) { this.element.unitDisplay = value; }
  get unitDisplay() { return this.element.unitDisplay; }

  @Input() set notation(value) { this.element.notation = value; }
  get notation() { return this.element.notation; }

  @Input() set signDisplay(value) { this.element.signDisplay = value; }
  get signDisplay() { return this.element.signDisplay; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-field-message', standalone: true })
export class BpFieldMessageDirective {
  protected element: Partial<BpFieldMessage>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set error(value) { this.element.error = value; }
  get error() { return this.element.error; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-field', standalone: true })
export class BpFieldDirective {
  protected element: Partial<BpField>;

  @Input() set layout(value) { this.element.layout = value; }
  get layout() { return this.element.layout; }

  @Input() set controlWidth(value) { this.element.controlWidth = value; }
  get controlWidth() { return this.element.controlWidth; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-fieldset', standalone: true })
export class BpFieldsetDirective {
  protected element: Partial<BpFieldset>;

  @Input() set responsive(value: boolean | '') { this.element.responsive = value === '' ? true : value; }
  get responsive() { return this.element.responsive; }

  @Input() set layout(value) { this.element.layout = value; }
  get layout() { return this.element.layout; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-form-group', standalone: true })
export class BpFormGroupDirective {
  protected element: Partial<BpFormGroup>;

  @Input() set layout(value) { this.element.layout = value; }
  get layout() { return this.element.layout; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-header', standalone: true })
export class BpHeaderDirective {
  protected element: Partial<BpHeader>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-header-item', standalone: true })
export class BpHeaderItemDirective {
  protected element: Partial<BpHeaderItem>;

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-input', standalone: true })
export class BpInputDirective {
  protected element: Partial<BpInput>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-menu', standalone: true })
export class BpMenuDirective {
  protected element: Partial<BpMenu>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-menu-item', standalone: true })
export class BpMenuItemDirective {
  protected element: Partial<BpMenuItem>;

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-month', standalone: true })
export class BpMonthDirective {
  protected element: Partial<BpMonth>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-nav', standalone: true })
export class BpNavDirective {
  protected element: Partial<BpNav>;

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set expandable(value: boolean | '') { this.element.expandable = value === '' ? true : value; }
  get expandable() { return this.element.expandable; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set interaction(value) { this.element.interaction = value; }
  get interaction() { return this.element.interaction; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-nav-group', standalone: true })
export class BpNavGroupDirective {
  protected element: Partial<BpNavGroup>;

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set interaction(value) { this.element.interaction = value; }
  get interaction() { return this.element.interaction; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-nav-item', standalone: true })
export class BpNavItemDirective {
  protected element: Partial<BpNavItem>;

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-pagination', standalone: true })
export class BpPaginationDirective {
  protected element: Partial<BpPagination>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-pagination-input', standalone: true })
export class BpPaginationInputDirective {
  protected element: Partial<BpPaginationInput>;

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Input() set sizeOptions(value) { this.element.sizeOptions = value; }
  get sizeOptions() { return this.element.sizeOptions; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('size') sizeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-password', standalone: true })
export class BpPasswordDirective {
  protected element: Partial<BpPassword>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-popover', standalone: true })
export class BpPopoverDirective {
  protected element: Partial<BpPopover>;

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set anchor(value) { this.element.anchor = value; }
  get anchor() { return this.element.anchor; }

  @Input() set trigger(value) { this.element.trigger = value; }
  get trigger() { return this.element.trigger; }

  @Input() set modal(value: boolean | '') { this.element.modal = value === '' ? true : value; }
  get modal() { return this.element.modal; }

  @Input() set focusTrap(value: boolean | '') { this.element.focusTrap = value === '' ? true : value; }
  get focusTrap() { return this.element.focusTrap; }

  @Input() set arrow(value: boolean | '') { this.element.arrow = value === '' ? true : value; }
  get arrow() { return this.element.arrow; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-progress-bar', standalone: true })
export class BpProgressBarDirective {
  protected element: Partial<BpProgressBar>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-progress-circle', standalone: true })
export class BpProgressCircleDirective {
  protected element: Partial<BpProgressCircle>;

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set line(value) { this.element.line = value; }
  get line() { return this.element.line; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-progress-dot', standalone: true })
export class BpProgressDotDirective {
  protected element: Partial<BpProgressDot>;

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-radio', standalone: true })
export class BpRadioDirective {
  protected element: Partial<BpRadio>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set checked(value: boolean | '') { this.element.checked = value === '' ? true : value; }
  get checked() { return this.element.checked; }

  @Input() set indeterminate(value: boolean | '') { this.element.indeterminate = value === '' ? true : value; }
  get indeterminate() { return this.element.indeterminate; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-range', standalone: true })
export class BpRangeDirective {
  protected element: Partial<BpRange>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set step(value) { this.element.step = value; }
  get step() { return this.element.step; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-rating', standalone: true })
export class BpRatingDirective {
  protected element: Partial<BpRating>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-search', standalone: true })
export class BpSearchDirective {
  protected element: Partial<BpSearch>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-select', standalone: true })
export class BpSelectDirective {
  protected element: Partial<BpSelect>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-shell', standalone: true })
export class BpShellDirective {
  protected element: Partial<BpShell>;

  @Input() set breakpoint(value) { this.element.breakpoint = value; }
  get breakpoint() { return this.element.breakpoint; }

  @Input() set open(value: boolean | '') { this.element.open = value === '' ? true : value; }
  get open() { return this.element.open; }

  @Input() set interaction(value) { this.element.interaction = value; }
  get interaction() { return this.element.interaction; }

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Output('scroll') scrollEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-stepper', standalone: true })
export class BpStepperDirective {
  protected element: Partial<BpStepper>;

  @Input() set layout(value) { this.element.layout = value; }
  get layout() { return this.element.layout; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-stepper-item', standalone: true })
export class BpStepperItemDirective {
  protected element: Partial<BpStepperItem>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-switch', standalone: true })
export class BpSwitchDirective {
  protected element: Partial<BpSwitch>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set checked(value: boolean | '') { this.element.checked = value === '' ? true : value; }
  get checked() { return this.element.checked; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tabs', standalone: true })
export class BpTabsDirective {
  protected element: Partial<BpTabs>;

  @Input() set layout(value) { this.element.layout = value; }
  get layout() { return this.element.layout; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tab-list', standalone: true })
export class BpTabListDirective {
  protected element: Partial<BpTabList>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tab-panel', standalone: true })
export class BpTabPanelDirective {
  protected element: Partial<BpTabPanel>;


  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tab', standalone: true })
export class BpTabDirective {
  protected element: Partial<BpTab>;

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tag', standalone: true })
export class BpTagDirective {
  protected element: Partial<BpTag>;

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Input() set pressed(value: boolean | '') { this.element.pressed = value === '' ? true : value; }
  get pressed() { return this.element.pressed; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set popoverTargetElement(value) { this.element.popoverTargetElement = value; }
  get popoverTargetElement() { return this.element.popoverTargetElement; }

  @Input() set popoverTargetAction(value) { this.element.popoverTargetAction = value; }
  get popoverTargetAction() { return this.element.popoverTargetAction; }

  @Input() set popovertarget(value) { this.element.popovertarget = value; }
  get popovertarget() { return this.element.popovertarget; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-textarea', standalone: true })
export class BpTextareaDirective {
  protected element: Partial<BpTextarea>;

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-time', standalone: true })
export class BpTimeDirective {
  protected element: Partial<BpTime>;

  @Input() set type(value) { this.element.type = value; }
  get type() { return this.element.type; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set value(value) { this.element.value = value; }
  get value() { return this.element.value; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set required(value: boolean | '') { this.element.required = value === '' ? true : value; }
  get required() { return this.element.required; }

  @Input() set readonly(value) { this.element.readonly = value; }
  get readonly() { return this.element.readonly; }

  @Input() set multiple(value: boolean | '') { this.element.multiple = value === '' ? true : value; }
  get multiple() { return this.element.multiple; }

  @Input() set autocomplete(value) { this.element.autocomplete = value; }
  get autocomplete() { return this.element.autocomplete; }

  @Input() set pattern(value) { this.element.pattern = value; }
  get pattern() { return this.element.pattern; }

  @Input() set placeholder(value) { this.element.placeholder = value; }
  get placeholder() { return this.element.placeholder; }

  @Input() set minLength(value) { this.element.minLength = value; }
  get minLength() { return this.element.minLength; }

  @Input() set maxLength(value) { this.element.maxLength = value; }
  get maxLength() { return this.element.maxLength; }

  @Input() set min(value) { this.element.min = value; }
  get min() { return this.element.min; }

  @Input() set max(value) { this.element.max = value; }
  get max() { return this.element.max; }

  @Input() set size(value) { this.element.size = value; }
  get size() { return this.element.size; }

  @Output('input') inputEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('change') changeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-toast', standalone: true })
export class BpToastDirective {
  protected element: Partial<BpToast>;

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set anchor(value) { this.element.anchor = value; }
  get anchor() { return this.element.anchor; }

  @Input() set trigger(value) { this.element.trigger = value; }
  get trigger() { return this.element.trigger; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Input() set status(value) { this.element.status = value; }
  get status() { return this.element.status; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tooltip', standalone: true })
export class BpTooltipDirective {
  protected element: Partial<BpTooltip>;

  @Input() set closable(value: boolean | '') { this.element.closable = value === '' ? true : value; }
  get closable() { return this.element.closable; }

  @Input() set position(value) { this.element.position = value; }
  get position() { return this.element.position; }

  @Input() set anchor(value) { this.element.anchor = value; }
  get anchor() { return this.element.anchor; }

  @Input() set trigger(value) { this.element.trigger = value; }
  get trigger() { return this.element.trigger; }

  @Input() set i18n(value) { this.element.i18n = value; }
  get i18n() { return this.element.i18n; }

  @Output('open') openEvent: EventEmitter<CustomEvent> = new EventEmitter();

  @Output('close') closeEvent: EventEmitter<CustomEvent> = new EventEmitter();
  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tree', standalone: true })
export class BpTreeDirective {
  protected element: Partial<BpTree>;

  @Input() set interaction(value) { this.element.interaction = value; }
  get interaction() { return this.element.interaction; }

  @Input() set selectable(value) { this.element.selectable = value; }
  get selectable() { return this.element.selectable; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}

@Directive({ selector: 'bp-tree-item', standalone: true })
export class BpTreeItemDirective {
  protected element: Partial<BpTreeItem>;

  @Input() set expanded(value: boolean | '') { this.element.expanded = value === '' ? true : value; }
  get expanded() { return this.element.expanded; }

  @Input() set selected(value: boolean | '') { this.element.selected = value === '' ? true : value; }
  get selected() { return this.element.selected; }

  @Input() set indeterminate(value: boolean | '') { this.element.indeterminate = value === '' ? true : value; }
  get indeterminate() { return this.element.indeterminate; }

  @Input() set disabled(value: boolean | '') { this.element.disabled = value === '' ? true : value; }
  get disabled() { return this.element.disabled; }

  @Input() set readonly(value: boolean | '') { this.element.readonly = value === '' ? true : value; }
  get readonly() { return this.element.readonly; }

  constructor(elementRef: ElementRef) {
    this.element = elementRef.nativeElement;
  }
}