import { Package } from 'custom-elements-manifest/schema';
export interface CustomElement {
    name: string;
    tagName: string;
    path: string;
    import: string;
    importType: string;
    description: string;
    propeties: {
        name: string;
        type: string;
    }[];
    events: {
        name: string;
    }[];
    cssProperties: any[];
    slots: any[];
}
export interface CustomElementMetadata {
    entrypoint: string;
    elements: CustomElement[];
}
export declare function createElementMetadata(customElementsManifest: Package, entrypoint: any): CustomElement[];
export declare const generatedMessage = "Generated with https://github.com/blueprintui/custom-element-types";
